/// <reference types="debug" />
import { ArrayLiteralExpression, Node, TypeNode } from 'typescript';
import { ResponseType } from './metadataGenerator';
export declare abstract class EndpointGenerator<T extends Node> {
    protected node: T;
    protected constructor(node: T, name: string);
    protected debugger: import("debug").Debugger;
    protected getDecoratorValues(decoratorName: string, acceptMultiple?: boolean): any[];
    protected getSecurity(): {
        name: any;
        scopes: string[];
    }[];
    protected handleRolesArray(argument: ArrayLiteralExpression): Array<string>;
    protected getExamplesValue(argument: any): any;
    protected getInitializerValue(initializer: any): any;
    protected getResponses(genericTypeMap?: Map<String, TypeNode>): Array<ResponseType>;
    protected abstract getCurrentLocation(): string;
}
